import	java.lang.*;
import	java.io.*;
import	java.util.*;

import	java.util.Hashtable;
import	java.util.Properties;

import	javax.naming.directory.*;
import	javax.naming.*;

import	library.*;

public class LDAP_Code_Ex
    {
    public LDAP_Code_Ex( )
	{

	Ctx	= new DirectoryService( "O=SEB", "SEB177", Trace_ );

	Ctx.simpleBind( "SEBUI=X12348,O=SEB", "ldaptest", null );

LinkedList	reslis	= null;

	System.out.println( "\n--------------- Get list of current attributes ---------------------\n");

	reslis	= Ctx.getListByDN( "SEBUI=X12348" );

	int	ridx	= 0;
	int	rmax	= reslis.size( );

	while ( ridx < rmax )
	    {
	    Attribute result	= ( Attribute ) reslis.get( ridx );
	    try
		{
		System.out.print( "" + ridx + " = " + result.getID( ) + " = " );
		if ( result.size( ) > 0 )
		    {
		    System.out.println( "" + result.get( ) );
		    }
		  else
		    {
		    System.out.println( "<No Value>" );
		    }
		}
	    catch( NamingException ne )
		{
		System.out.println( "ERROR :" + ne.getMessage( ));
		}
	    ridx++;
	    }

	System.out.println( "\n--------------- Get value of attribute 'telephoneNumber' ---------------------\n");

String	res_s	= null;

	res_s	= ( String ) Ctx.getAttrValueByDN( "SEBUI=X12348", "telephoneNumber" );

	System.out.println( "Result for telephoneNumber = " + res_s );

	System.out.println("--------------- Search by attributes ---------------------");

	BasicAttributes bas	= new BasicAttributes( true );
		bas.put( "sebApplName", ( Object ) "SEBTRADE" );
		bas.put( "sebApplArea", ( Object ) "SEB177" );
		bas.put( "sebApplEnv", ( Object ) "T1" );

	res_s	= Ctx.getDNFromAttr( "", bas );

	System.out.println( "Name for attribute search = " + res_s );

	System.out.println("--------------- Result of attribute search ---------------------");

	reslis	= Ctx.getListByAttrs( "", bas );

	ridx	= 0;
	rmax	= reslis.size( );

	while ( ridx < rmax )
	    {
	    Attribute result	= ( Attribute ) reslis.get( ridx );
	    try
		{
		System.out.print( "" + ridx + " = " + result.getID( ) + " = " );
		if ( result.size( ) > 0 )
		    {
		    System.out.println( "" + result.get( ) );
		    }
		  else
		    {
		    System.out.println( "<No Value>" );
		    }
		}
	    catch( NamingException ne )
		{
		System.out.println( "ERROR :" + ne.getMessage( ));
		}
	    ridx++;
	    }

	System.out.println("--------------- Try to add a new entry ---------------------");

	BasicAttributes attrs           = new BasicAttributes( "objectClass", "sebUser" );

	BasicAttribute  a_user  = new BasicAttribute( "sebUserId", "X12345" );
	BasicAttribute  a_ou    = new BasicAttribute( "organizationalUnit", "CSD" );
	BasicAttribute  a_sn    = new BasicAttribute( "surName", "John" );
	BasicAttribute  a_gn    = new BasicAttribute( "givenName", "Barker" );
	BasicAttribute  a_cn    = new BasicAttribute( "commonName", "John Barker" );

        attrs.put( a_user );
        attrs.put( a_ou );
        attrs.put( a_sn );
        attrs.put( a_gn );
        attrs.put( a_cn );

	Ctx.setFollowReferral( true );

boolean	insertedOK	= false;

	Ctx.addEntryWithAttrs( "SEBUI=X12345", attrs );

	if ( insertedOK	== false )
	    {
	    if( Ctx.removeEntryByDN( "SEBUI=X12345" ))
		{
		System.out.println( "Entry removed" );
		}
	    }

	if ( insertedOK == false )
	    {
	    if ( Ctx.addEntryWithAttrs( "SEBUI=X12345", attrs ))
		{
		System.out.println( "Entry inserted second time" );
		}
	      else
		{
		System.out.println( "Add of entry failed twice ! " );
		}
	    }

	System.out.println("--------------- Get list of attributes for the newly added entry ---------------------");

	reslis	= Ctx.getListByDN( "SEBUI=X12345" );

	ridx	= 0;
	rmax	= reslis.size( );

	while ( ridx < rmax )
	    {
	    Attribute result	= ( Attribute ) reslis.get( ridx );
	    try
		{
		System.out.print( "" + ridx + " = " + result.getID( ) + " = " );
		if ( result.size( ) > 0 )
		    {
		    System.out.println( "" + result.get( ) );
		    }
		  else
		    {
		    System.out.println( "<No Value>" );
		    }
		}
	    catch( NamingException ne )
		{
		System.out.println( "ERROR :" + ne.getMessage( ));
		}
	    ridx++;
	    }

	System.out.println( "\n--------------- Get value for attribute 'rfc822Mailbox' ---------------------\n");

	res_s	= ( String ) Ctx.getAttrValueByDN( "SEBUI=X12348", "rfc822Mailbox" );

	System.out.println( "Result for rfc822Mailbox = " + res_s );

	System.out.println( "\n--------------- Modify attribute 'rfc822Mailbox' ---------------------\n");

	attrs           = new BasicAttributes( "rfc822Mailbox", "test.user@seb.se" );

	Ctx.addAttrByDN( "SEBUI=X12348", attrs  );

	res_s	= ( String ) Ctx.getAttrValueByDN( "SEBUI=X12348", "rfc822Mailbox" );

	System.out.println( "Result for rfc822Mailbox after insert = " + res_s );

	System.out.println( "\n--------------- Modify previously inserted attribute 'rfc822Mailbox' ---------------------\n");

	attrs           = new BasicAttributes( "rfc822Mailbox", "info@seb.se" );

	Ctx.modifyAttrByDN( "SEBUI=X12348", attrs  );

	res_s	= ( String ) Ctx.getAttrValueByDN( "SEBUI=X12348", "rfc822Mailbox" );

	System.out.println( "Result for rfc822Mailbox after modify = " + res_s );

	System.out.println( "\n--------------- Remove attribute 'rfc822Mailbox' ---------------------\n" );

	Ctx.removeAttrByDN( "SEBUI=X12348", attrs  );

	res_s	= ( String ) Ctx.getAttrValueByDN( "SEBUI=X12348", "rfc822Mailbox" );

	System.out.println( "Result for rfc822Mailbox after remove = " + res_s );

	System.out.println( "\n--------------- Close directory ---------------------\n");

	Ctx.close( );

	}						// End of constructor LDAP_Code_Ex( )

   public static void main( String[] args )
        {

LDAP_Code_Ex	x = new LDAP_Code_Ex( );

	}					// End of main( )
//
// Class variables
//

DirectoryService	Ctx	= null;

TraceInfo	Trace_	= new TraceInfo( );
    }							// End of class LDAP_Code_Ex( )
