import	java.lang.*;
import	java.io.*;
import	java.util.*;

import	java.util.Hashtable;
import	java.util.Properties;

import	javax.naming.directory.*;
import	javax.naming.*;

import	library.*;

public class LDAP_Execute
    {
    public LDAP_Execute( )
	{

	Trace_	= new TraceInfo( System.out );

	Trace_.setTraceSelection( TraceInfo.DEBUG );

	Ctx	= new DirectoryService( "O=SEB", "SEB177", Trace_ );

	Ctx.simpleBind( "SEBUI=X12348,O=SEB", "ldaptest", null );

LinkedList	reslis	= null;

	System.out.println( "\n--------------- Get list of current attributes ---------------------");

	reslis	= Ctx.getListByDN( "SEBUI=X12348" );

	int	ridx	= 0;
	int	rmax	= reslis.size( );

	while ( ridx < rmax )
	    {
	    Attribute result	= ( Attribute ) reslis.get( ridx );
	    try
		{
		System.out.print( "" + ridx + " = " + result.getID( ) + " = " );
		if ( result.size( ) > 0 )
		    {
		    System.out.println( "" + result.get( ) );
		    }
		  else
		    {
		    System.out.println( "<No Value>" );
		    }
		}
	    catch( NamingException ne )
		{
		System.out.println( "ERROR :" + ne.getMessage( ));
		}
	    ridx++;
	    }

	System.out.println( "\n--------------- Get list of attribute 'telephoneNumber' ---------------------");

String		res_s	= null;
BasicAttributes	attrs	= null;

	Ctx.setFollowReferral( true );

	res_s	= ( String ) Ctx.getAttrValueByDN( "SEBUI=X12348", "telephoneNumber" );

	System.out.println( "Result for attribute 'telephoneNumber' = " + res_s );

	System.out.println( "\n--------------- Modify attribute 'rfc822Mailbox' ---------------------");

	res_s	= ( String ) Ctx.getAttrValueByDN( "SEBUI=X12348", "rfc822Mailbox" );

	System.out.println( "Result for attribute 'rfc822Mailbox' = " + res_s );

	System.out.println( "\n--------------- Add attribute 'rfc822Mailbox' ---------------------");

	attrs           = new BasicAttributes( "rfc822Mailbox", "test.user@seb.se" );

	Ctx.addAttrByDN( "SEBUI=X12348", attrs  );

	res_s	= ( String ) Ctx.getAttrValueByDN( "SEBUI=X12348", "rfc822Mailbox" );

	System.out.println( "Result for rfc822Mailbox after insert = " + res_s );

	System.out.println( "\n--------------- Modify previously inserted attribute 'rfc822Mailbox' ---------------------");

	attrs           = new BasicAttributes( "rfc822Mailbox", "info@seb.se" );

	Ctx.modifyAttrByDN( "SEBUI=X12348", attrs  );

	res_s	= ( String ) Ctx.getAttrValueByDN( "SEBUI=X12348", "rfc822Mailbox" );

	System.out.println( "Result for rfc822Mailbox after modify = " + res_s );

	System.out.println( "\n--------------- Remove attribute 'rfc822Mailbox' ---------------------" );

	Ctx.removeAttrByDN( "SEBUI=X12348", attrs  );

	res_s	= ( String ) Ctx.getAttrValueByDN( "SEBUI=X12348", "rfc822Mailbox" );

	System.out.println( "Result for rfc822Mailbox after remove = " + res_s );

	System.out.println( "\n--------------- Close directory ---------------------");

	Ctx.close( );

	}						// End of constructor LDAP_Execute( )

   public static void main( String[] args )
        {

LDAP_Execute	x = new LDAP_Execute( );

	}					// End of main( )
//
// Class variables
//

DirectoryService	Ctx	= null;

TraceInfo	Trace_	= new TraceInfo( );
    }							// End of class LDAP_Execute( )
